<template>
    <div>
        <breadcrumb-component title="Plano de contas" :pages="breadPages"/>

        <panel-component title="Listar plano de contas" :pages="breadPages">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'plano-contas.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar plano conta
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Pagamento</th>
                        <th>Proximo vencimento</th>
                        <th>Valor total</th>
                        <th>Situação</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="planoConta in planoContas.data">
                        <td>{{planoConta.name}}</td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td>{{planoConta.created_at | dateFormat}}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'planoContas.edit', params: {id: planoConta.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(planoConta)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'plano-contas', name: 'Financeiro', active: false},
                    {link: 'plano-contas', name: 'Plano de contas', active: false},
                    {link: 'plano-contas', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadPlanoContas()
        },

        computed: {
            planoContas() {
                return this.$store.state.planoContas.items
            }
        },

        methods: {
            loadPlanoContas() {
                this.$store.dispatch('loadPlanoContas')
            },

            confirmDestroy(planoConta) {
                this.$snotify.confirm(`Deseja realmente apagar o plano de conta: ${planoConta.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyPlanoConta(planoConta.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyPlanoConta(id) {
                this.$store.dispatch('destroyPlanoConta', id)
                    .then(() => {
                        this.loadPlanoContas()
                        this.$snotify.success('Registro apagado com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar o registro!', 'Error')
                    })
            }
        }
    }
</script>